package bookstoreAcceptable;

/**
* <h1>Book</h1>
* Class responsible from handling all 
* the Book items.
*
* @version 1.0
* @since   2017-07-17
*/


public final class Book extends Item {

	public enum PackageType{
		SIMPLE, HARD;
	}
	
	private String author;
	private PackageType packaging; 
	private int yearPublished;

	public Book(String aTitle, String anAuthor, int aDate, double aPrice,
			PackageType aPackageType, int id) {
		
		super(aTitle, aPrice, id); //constructor of Item!!!
		author = anAuthor;
		packaging = aPackageType;
		yearPublished = aDate;
	}

	@Override
	public String showDetails() {
		String packString = this.packaging.name().toLowerCase() + " packaging";
		String result = "***Item id: " + id + "***\n" +
					title + "\t\t Price:" + price + "\n" +
					" by " + author + " at " + yearPublished +  "\n" + 
					"with " + packString + ".\n\n";
		return result;
	}
	
	@Override
	public String getDetails(){
		String packString = this.packaging.name().toLowerCase() + " packaging";
		return (title + "\nby " + author + " at " + yearPublished 
				+ "\nwith " + packString 	+ "\n");
	}

	@Override
	public double getFinalPrice() {
		return price;
	}
}//end Book
