package bookstoreAcceptable;

/**
* <h1>Item</h1>
* Abstract class responsible for handling all 
* the different types of items.
* 
* To be subclassed with concrete materializations
* of items like Book's and CD's
* Intentionally not "final", therefore :)
*
* @version 1.0
* @since   2017-07-17
*/
public abstract class Item {
 	
 	protected String title;
	protected double price;
	protected int id;
	
	public Item(){title="";price=-1.0;id=-1;}
 	public Item(String aTitle, double aPrice,int id){title = aTitle; price=aPrice;this.id =id;}
 	
 	/**
 	 * Shows the information for an item
 	 */
 	public abstract String showDetails();
 	
 	/**
 	 * @return the information for an item
 	 */
 	public abstract String getDetails();

	/**
 	 * @return the price after discount of a selected item
 	 */
 	public abstract double getFinalPrice();
 	
 	/**
 	 * @return the title of an item
 	 */
 	public String getTitle(){return title;}
 	
 	/**
 	 * @return the id of an item
 	 */
 	public int getId(){return id;}
 	
 	/**
 	 * @return the original price of a selected item
 	 */
	public double getOriginalPrice(){return price;}

}

