package bookstoreAcceptable;

import java.util.Scanner;

public final class SimpleBookstoreApplication {

	private Scanner reader;

	public SimpleBookstoreApplication(){
		reader = new Scanner(System.in);
	}

	public int printMenu(){
		int answerOperation = 0;
		while( answerOperation > 5 || answerOperation <= 0){
			System.out.println("Choose(1-4)\n 1. Show items\n 2. Add item to cart\n 3. Show cart\n "
					+ "4. Remove item from cart\n 5. Exit");
			answerOperation = reader.nextInt();
			if(answerOperation > 5 || answerOperation <= 0)
				System.out.println("Wrong answer! Try again...");
		}

		return answerOperation;
	}

	public Scanner getReader(){
		return reader;
	}


	public static void main(String args[]){

		SimpleBookstoreApplication app = new SimpleBookstoreApplication();

		ItemManager itemManager = new ItemManager();

		//	Book bookRef;
		Item item = new Book("Discours de la methode","Rene Descartes", 1637, 50.00, Book.PackageType.SIMPLE, 0);
		itemManager.addItem(item);
		item = new Book("The Meditations",   "Marcus Aurelius", 180,30.00, Book.PackageType.SIMPLE,1);
		itemManager.addItem(item);
		item = new Book("The Bacchae","Euripides", -405,30.00, Book.PackageType.HARD,2);
		itemManager.addItem(item);
		item = new Book("The Trojan Women","Euripides",-415,40.00, Book.PackageType.SIMPLE,3);	
		itemManager.addItem(item);

		//CD cdRef;
		item = new CD("Piece of Mind", 10.0,"Iron Maiden",4.0,4);
		itemManager.addItem(item);
		item = new CD("Matter of Life and Death", 12.0,"Iron Maiden",2.0,5);
		itemManager.addItem(item);
		item = new CD("Perfect Strangers", 12.00, "Deep Purple",1.0,6);
		itemManager.addItem(item);

		ShoppingCart cart = new ShoppingCart();

		while(true){
			int operation = app.printMenu();
			if(operation == 1){
				itemManager.reportAllItems();
			}
			else if(operation == 2){
				System.out.println("Choose the id of the item that you want to add to your cart");
				int id = app.getReader().nextInt();
				System.out.println(id);
				if(id > itemManager.getAllItems().size())
					System.out.println("Error: there is no product with the specified id");
				else
					cart.addItem(itemManager.getItem(id));
			}
			else if(operation == 3){
				cart.showDetails();
			}
			else if(operation == 4){
				System.out.println("Choose the id of the item that you want to remove from your cart");
				int id = app.getReader().nextInt();
				System.out.println(id);
				if(id > itemManager.getAllItems().size())
					System.out.println("Error: there is no product with the specified id");
				else
					cart.removeItem(id);
			}
			else{
				break;
			}
		}//end while

	}//end main()
}//end class


