package test.testPackage;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import bookstoreAcceptable.Book;

public class BookTest {
	private Book bookToTest;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		//this runs once, before _all_ tests. Nothing todo here.
		//See CDTest for explanations
	}

	@Before
	public void setUp() throws Exception {
		bookToTest = new Book("Discours de la methode", "Rene Descartes", 1637, 50.00, Book.PackageType.SIMPLE, 1);
		//this runs before _each_ test. create a book to test constructor, price and final price 
	}



	@Test
	public final void testBookNull() {
		//remember: the setUp() method has run already: Book should have been initialized!
		assertNotNull("After setup, the book is not null", bookToTest);
		
		//at the beginning to see that the test works.
		//fail("Not yet implemented");
	}

	@Test
	public final void testBookNoTitle() {
	
		//See how this test fails. It gets a null title. The constructor should trap this 
		//and avoid creating a book without a tile. Unfortunately, it fails...
		bookToTest = new Book(null, "Rene Descartes", 1637, 50.00, Book.PackageType.SIMPLE, 2);
		assertNull("test if the constructor prevents creation with null title", bookToTest);
				
		//at the beginning to see that the test works.
		//fail("Not yet implemented");
	}
	
	@Test
	public final void testBookNegativePrice() {
	
		//should do the same with negative price. Again, intentionally put to show failure!
		bookToTest = new Book("Discours de la methode", "Rene Descartes", 1637, -12.00, Book.PackageType.SIMPLE, 3);
		assertNull("test if the constructor prevents creation with negative price", bookToTest);
		
		//at the beginning to see that the tes works.
		//fail("Not yet implemented");
	}
	

	@Test
	public final void testGetFinalPrice() {
		assertEquals("test if getFinalPrice() works OK", 50.00, bookToTest.getFinalPrice(), 3);
		//fail("Not yet implemented"); 
	}
	
	
	@Test
	public final void testGetPrice() {
		double actualValue = bookToTest.getOriginalPrice();
		double expectedValue = 50.00;
		assertEquals("test if getOriginalPrice of the ITEM CLASS works OK", expectedValue, actualValue, 3);
		//fail("Not yet implemented"); 
	}

}
